unit e_logicaU;

{* * * Elaborado e desenvolvido por Svio Cler em 2004 * * *}
{* * *       www.sgm.rg3.net - www.deephi.rg3.net      * * *}
{* * *               saviocler@ig.com.br               * * *}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Button1: TButton;
    SpeedButton1: TSpeedButton;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    Button2: TButton;
    Label1: TLabel;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Button11: TButton;
    procedure BitBtn1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Label1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Close; //Fecha aplicao

  //Neste boto, passando o mouse sobre o mesmo (quando em tempo de execuo - depois do F9),
  //aparece uma mensagem, que pode ser configurada na propriedade (no Object Inspector)
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  A,B: Integer; //Variveis no podem ter espaos, acentuao grfica
  X,Y: String;  //ou comear por nmeros
begin
  //A propriedade Caption (no Object Inspector) do boto foi alterado para '1 exerccio'
  //Estas linhas com // no incio, so apenas comentrios, sendo ignoradas pelo Delphi
  {Textos entre chaves tambm so comentrios}

  //Sempre teremos que converter o que foi digitado na tela, para nmeros
  //Ento neste exerccio, usaremos mais 2 variveis adicionais, X e Y, do tipo String (texto)
  //para demonstrar com mais detalhes a converso
  X := InputBox('1 exerccio','Digite o 1 nmero:','');
  Y := InputBox('1 exerccio','Digite o 2 nmero:','');

  //Convertemos X e Y, para nmeros e armazenamos em A e B
  //Ateno, pois se digitar letras os espaos e no nmeros, um erro surgir
  //Analisaremos estes erros, mais adiante
  A := StrToInt(X); //StrToInt = String to Integer = Texto para Inteiro
  B := StrToInt(Y);

  //Fazemos a comparao e apresentamos o resultado
  //Observe que a converso foi feita (de nmero para texto agora), na prpria exibio do valor
  //sem usarmos X e Y
  if A>B then ShowMessage( IntToStr(A) ) else ShowMessage( IntToStr(B) );
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
var
  A,B,C: Integer;
begin
  //Alteramos a propriedade Caption e tambm adicionamos uma imagem neste boto (BitBtn)
  //pela propriedade Glyph, no Object Inspector

  //No usaremos mais as variveis adicionais, fazendo a converso sempre direta

  A := StrToInt( InputBox('2 exerccio','Digite o 1 nmero:','') ); //A converso foi direta
  B := StrToInt( InputBox('2 exerccio','Digite o 2 nmero:','') ); //Os espaos dados somente visam facilitar
  C := StrToInt( InputBox('2 exerccio','Digite o 3 nmero:','') ); //o etendimento, no sendo obrigatrios

  //Fazemos a comparao e apresentamos o resultado
  if (A>B) and (A>C) then ShowMessage( IntToStr(A) ); //IntToStr = Integer to String = Inteiro para Texto
  if (B>A) and (B>C) then ShowMessage( IntToStr(B) );
  if (C>B) and (C>A) then ShowMessage( IntToStr(C) );
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
var
  Meu_Numero: Integer; //As variveis podem, e devem, ter nomes mais explicativos
begin
  //Este boto (SpeedButton) possui ainda a propriedade Flat, onde o mesmo fica
  //transparente se igual a True

  Meu_Numero := StrToInt( InputBox('3 exerccio','Digite um nmero:','') );

  if Meu_Numero>100 then Meu_Numero := Meu_Numero + 30; //Ele mesmo, mais 30 (muito utilizado em programao)

  ShowMessage( IntToStr(Meu_Numero) );
end;

procedure TForm1.BitBtn3Click(Sender: TObject);
var
  A: Integer;
begin
  A := StrToInt( InputBox('4 exerccio','Digite um nmero:','') );

  //Sempre que usamos and ou or, devemos separar as condies com parenteses, obrigatoriamente
  if (A<20) or (A>=180) then ShowMessage( IntToStr(A) );
end;

//Reparou que usamos IntToStr e StrToInt em todos os exerccios?
//Use sempre 2 espaos (no use TAB) para organizar seus cdigos

procedure TForm1.BitBtn4Click(Sender: TObject);
var
  A,B,C,D: Integer;
  Media: Real;
begin
  A := StrToInt(InputBox('5 exerccio','Digite a 1 nota:',''));
  B := StrToInt(InputBox('5 exerccio','Digite a 2 nota:',''));
  C := StrToInt(InputBox('5 exerccio','Digite a 3 nota:',''));
  D := StrToInt(InputBox('5 exerccio','Digite a 4 nota:',''));
  Media := (A+B+C+D)/4;
  if Media>=6 then
    ShowMessage('Aprovado')  //Aqui ocorreu quebra de linhas apenas para facilitar a visualizao
  else
    ShowMessage('Reprovado com mdia '+FloatToStr(Media)); //Observe que convertemos agora um nmero real para texto,
end;                                                       //usando FloatToStr e no InttoStr.
                                                           //Veja tanbm que fizemos uma CONCATENAO de "Reprovado com mdia"
                                                           //e a varivel MEDIA (que foi convertida para texto).

procedure TForm1.Button2Click(Sender: TObject);
var
  A,B,C,D,X,Y: Integer;
  Z: Real;
begin
  A := StrToInt(InputBox('6 exerccio','Digite o 1 nmero:',''));
  B := StrToInt(InputBox('6 exerccio','Digite o 2 nmero:',''));
  C := StrToInt(InputBox('6 exerccio','Digite o 3 nmero:',''));
  D := StrToInt(InputBox('6 exerccio','Digite o 4 nmero:',''));

  X:=A-B;
  ShowMessage('Subtrao do 1 pelo 2: '+IntToStr(X));

  Y:=B*C;
  ShowMessage('Multiplicao do 2 pelo 3: '+IntToStr(Y));

  Z:=C/D;
  ShowMessage('Diviso do 3 pelo 4: '+FloatToStr(Z)); //Aqui usamos FloatToStr, pois Z  um nmero real

  ShowMessage('Soma dos 3 resultados anteriores: '+FloatToStr(X+Y+Z)); //No podemos usar IntToStr e sim FloatToStr,
end;                                                                   //pois nmeros inteiros + nmeros reais,
                                                                       //resulta em um nmero real

procedure TForm1.Label1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  ShowMessage('Voc chamou o evento OnMouseMove desde texto (label).'+#13+'No Object Inspector (F11) ele est na guia Events.');
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  x: Integer; //Em repeties, devemos a maioria das vezes usar uma varivel auxiliar, para contagem
begin
  //1 soluo - para
  ShowMessage('Usando for');
  for x := 1 to 10 do
    ShowMessage(IntToStr(x));

  //2 soluo - enquanto
  ShowMessage('Usando while');
  x := 0; //Vamos usar uma contagem, devemos sempre inicializar as variveis nestes casos
  while x < 10 do
  begin
    x := x + 1; //Aqui incrementamos a varivel x, para chegar a 10
    ShowMessage(IntToStr(x));
  end;

  //3 soluo - repetir
  ShowMessage('Usando repeat');
  x := 0;
  repeat
    x := x + 1;
    ShowMessage(IntToStr(x));
  until x >= 10
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  x: Integer;
begin
  //Como sabemos o nmero de repeties, usamos for
  for x := 0 to 99 do
    ShowMessage(IntToStr(x*2));
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  x, Numero, p, n, z: Integer;
begin
  p := 0;
  n := 0;
  z := 0;
  for x := 1 to 33 do
  begin
    Numero := StrToInt(InputBox('9 exerccio','Digite um nmero:',''));
    if Numero > 0 then p:=p+1;
    if Numero < 0 then n:=n+1;
    if Numero = 0 then z:=z+1;
  end;
  ShowMessage('Positivos: '+IntToStr(p));
  ShowMessage('Negativos: '+IntToStr(n));
  ShowMessage('Zero: '+IntToStr(z));
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  x, y, Idade, Soma_Idade:Integer;
begin
  y := 0; //Somente devido a solicitao 10.3
  Soma_Idade := 0; //Esta varivel ser um contador (na verdade, um acumulador), ento deve ser inicializada
  for x := 1 to 50 do
  begin
    Idade := StrToInt(InputBox('10 exerccio','Digite a idade:',''));
    Soma_Idade := Soma_Idade + Idade;

    //Modificao solicitada no item 10.3
    y := y + 1;
    if y = 10 then
    begin
      y:=0;
      ShowMessage('Soma das idades: '+IntToStr(Soma_Idade));
    end;
    
  end;
  ShowMessage('Soma das idades: '+IntToStr(Soma_Idade));
  ShowMessage('Mdia das idades: '+FloatToStr(Soma_Idade/50)); //Usamos FloatToStr, pois um nmero inteiro dividido por outro, pode resultar um nmero real
end;

procedure TForm1.Button7Click(Sender: TObject);
var
  x, Altura, Peso, Idade, Soma_Altura, Soma_Peso, Soma_Idade, Maiores, Menores: Integer;
begin
  Soma_Altura := 0; //Podemos arrumar o cdigo, para ficar mais fcil de ler, com espaos, linhas, etc
  Soma_Peso   := 0;
  Soma_Idade  := 0;
  Maiores     := 0;
  Menores     := 0;

  for x:=1 to 40 do
  begin
    Altura := StrToInt(InputBox('11 exerccio','Digite a altura (cm):',''));
    Peso   := StrToInt(InputBox('11 exerccio','Digite o peso (kg):',''));
    Idade  := StrToInt(InputBox('11 exerccio','Digite a idade (anos):',''));

    if Idade >= 18 then Maiores := Maiores + 1 else Menores :=  Menores + 1;

    Soma_Altura := Soma_Altura + Altura;
    Soma_Peso   := Soma_Peso   + Peso;
    Soma_Idade  := Soma_Idade  + Idade;
  end;

  ShowMessage('Maiores de 18: '+IntToStr(Maiores));
  ShowMessage('Menores de 18: '+IntToStr(Menores));
  ShowMessage('Mdia da altura: '+FloatToStr(Soma_Altura/40));
  ShowMessage('Mdia da peso: '+FloatToStr(Soma_Peso/40));
  ShowMessage('Mdia da idade: '+FloatToStr(Soma_Idade/40));
end;

procedure TForm1.Button8Click(Sender: TObject);
var
  x, Idade, Pre_Mirim, Mirim, Infantil, Infanto_Juvenil, Nenhuma_Categoria: Integer;
begin
  Pre_Mirim         := 0;
  Mirim             := 0;
  Infantil          := 0;
  Infanto_Juvenil   := 0;
  Nenhuma_Categoria := 0;

  for x:=1 to 45 do
  begin
    Idade  := StrToInt(InputBox('12 exerccio','Digite a idade do '+IntToStr(x)+' jogador:','')); //Observe aqui um detalhe, com a varivel x no InputBox.
                                                                                                    //Veja como fica ao executar o programa.
    if (Idade > 11) and (Idade <= 13) then Pre_Mirim         := Pre_Mirim         + 1;
    if (Idade > 13) and (Idade <= 15) then Mirim             := Mirim             + 1;
    if (Idade > 15) and (Idade <= 17) then Infantil          := Infantil          + 1;
    if (Idade > 17) and (Idade <= 18) then Infanto_Juvenil   := Infanto_Juvenil   + 1;
    if (Idade > 18) or  (Idade <= 11) then Nenhuma_Categoria := Nenhuma_Categoria + 1;
  end;

  ShowMessage('Pr-Mirim: '       +IntToStr(Pre_Mirim));
  ShowMessage('Mirim: '           +IntToStr(Mirim));
  ShowMessage('Infantil: '        +IntToStr(Infantil));
  ShowMessage('Infanto-Juvenil: ' +IntToStr(Infanto_Juvenil));
  ShowMessage('Sem categoria: '   +IntToStr(Nenhuma_Categoria));

  if Pre_Mirim       >= 10 then ShowMessage('Pr-Mirim pode competir');
  if Mirim           >= 10 then ShowMessage('Mirim pode competir');
  if Infantil        >= 10 then ShowMessage('Infantil pode competir');
  if Infanto_Juvenil >= 10 then ShowMessage('Infanto-Juvenil pode competir');
end;

procedure TForm1.Button9Click(Sender: TObject);
var
  Horas: Integer;
  Salario_Bruto, Imposto: Real;
begin
  Imposto := 0; //Devemos inicializar Imposto, pois o mesmo s  calculado para salrios maiores que R$ 800,00
  Horas := StrToInt(InputBox('13 exerccio','Informe o total de horas trabalhadas:',''));
  if Horas <=50 then Salario_Bruto := Horas * 15 else Salario_Bruto := (50*15)   + ((Horas-50) * 20);
                                                                   //Hora normal +    Hora extra
  if Salario_Bruto>800 then Imposto := Salario_Bruto * 8 /100;

  ShowMessage('Salrio bruto: '   +FloatToStrF(Salario_Bruto         ,ffCurrency ,18 ,2)); //Observe que usamos um FloatToStr diferente, com a
  ShowMessage('Imposto: '         +FloatToStrF(Imposto               ,ffCurrency ,18 ,2)); //mesma funo, mas com a opo de formatao do valor.
  ShowMessage('Salrio lquido: ' +FloatToStrF(Salario_Bruto-Imposto ,ffCurrency ,18 ,2)); //Colocamos um F no fim do termo FloatToStr - FloattoStrF
end;

procedure TForm1.Button10Click(Sender: TObject);
var
  A, B, C: Integer;
begin
  A := StrToInt(InputBox('14 exerccio','Digite o 1 valor:',''));
  B := StrToInt(InputBox('14 exerccio','Digite o 2 valor:',''));
  C := StrToInt(InputBox('14 exerccio','Digite o 3 valor:',''));
  if (A = B) and (B = C) then ShowMessage('Tringulo equiltero')
  else
    if (A <> B) and (A <> C) and (B <> C) then ShowMessage('Tringulo escaleno')
    else
      ShowMessage('Tringulo issceles');

  {Observao importante:
     Este exerccio deveria informar tambm se os valores digitados formam um tringulo,
     fazendo a verificao e evitando assim qualquer erro futuro.
     A programao no deve resolver apenas os problemas que se pedem, mas ir alm e
     identificar possveis falhas e desenvolver solues criativas.}
end;

procedure TForm1.Button11Click(Sender: TObject);
var
  A: array [1..3] of Integer; //So na verdade 3 variveis: A[1], A[2] e A[3].
  B, x, y: Integer;
begin
  A[1] := StrToInt(InputBox('15 exerccio','Digite o 1 valor:',''));
  A[2] := StrToInt(InputBox('15 exerccio','Digite o 2 valor:',''));
  A[3] := StrToInt(InputBox('15 exerccio','Digite o 3 valor:',''));

  for y := 1 to 3 do
  begin
    for x := 1 to 3 do
    begin
      if A[x]>A[x+1] then
      begin
        B      := A[x+1];
        A[x+1] := A[x];
        A[x]   := B;
      end;
    end;
  end;
  ShowMessage(IntToStr(A[1])+', '+IntToStr(A[2])+', '+IntToStr(A[3]));
end;

end.


